2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless (show | drop | pop ) [<stash>]
7 or: $dashless apply [--index] [<stash>]
8 or: $dashless branch <branchname> [<stash>]
9 or: $dashless [save [--keep-index] [<message>]]
18 TMP="$GIT_DIR/.git-stash.$$"
19 trap 'rm -f "$TMP-*"' 0
24 git diff-index --quiet --cached HEAD --ignore-submodules -- &&
25 git diff-files --quiet --ignore-submodules
31 die "git stash clear with parameters is unimplemented"
33 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
35 git update-ref -d $ref_stash $current
47 # state of the base commit
48 if b_commit=$(git rev-parse --verify HEAD)
50 head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
52 die "You do not have the initial commit yet"
55 if branch=$(git symbolic-ref -q HEAD)
57 branch=${branch#refs/heads/}
61 msg=$(printf '%s: %s' "$branch" "$head")
64 i_tree=$(git write-tree) &&
65 i_commit=$(printf 'index on %s\n' "$msg" |
66 git commit-tree $i_tree -p $b_commit) ||
67 die "Cannot save the current index state"
69 # state of the working tree
72 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
73 GIT_INDEX_FILE="$TMP-index" &&
74 export GIT_INDEX_FILE &&
75 git read-tree -m $i_tree &&
80 die "Cannot save the current worktree state"
83 if test -z "$stash_msg"
85 stash_msg=$(printf 'WIP on %s' "$msg")
87 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
89 w_commit=$(printf '%s\n' "$stash_msg" |
90 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
91 die "Cannot record working tree state"
106 echo 'No local changes to save'
109 test -f "$GIT_DIR/logs/$ref_stash" ||
110 clear_stash || die "Cannot initialize stash"
112 create_stash "$stash_msg"
114 # Make sure the reflog for stash is kept.
115 : >>"$GIT_DIR/logs/$ref_stash"
117 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
118 die "Cannot save the current status"
119 printf 'Saved working directory and index state "%s"\n' "$stash_msg"
123 if test -n "$keep_index" && test -n $i_tree
125 git read-tree --reset -u $i_tree
130 git rev-parse --verify $ref_stash >/dev/null 2>&1
134 have_stash || return 0
135 git log --no-color --pretty=oneline -g "$@" $ref_stash -- |
136 sed -n -e 's/^[.0-9a-f]* refs\///p'
140 flags=$(git rev-parse --no-revs --flags "$@")
145 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
147 w_commit=$(git rev-parse --verify "$s") &&
148 b_commit=$(git rev-parse --verify "$s^") &&
149 git diff $flags $b_commit $w_commit
153 git diff-files --quiet --ignore-submodules ||
154 die 'Cannot restore on top of a dirty state'
163 # current index state
164 c_tree=$(git write-tree) ||
165 die 'Cannot apply a stash in the middle of a merge'
167 # stash records the work tree, and is a merge between the
168 # base commit (first parent) and the index tree (second parent).
169 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
170 w_tree=$(git rev-parse --verify "$s:") &&
171 b_tree=$(git rev-parse --verify "$s^1:") &&
172 i_tree=$(git rev-parse --verify "$s^2:") ||
173 die "$*: no valid stashed state found"
175 unstashed_index_tree=
176 if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
177 test "$c_tree" != "$i_tree"
179 git diff-tree --binary $s^2^..$s^2 | git apply --cached
181 die 'Conflicts in index. Try without --index.'
182 unstashed_index_tree=$(git-write-tree) ||
183 die 'Could not save index tree'
188 GITHEAD_$w_tree='Stashed changes' &&
189 GITHEAD_$c_tree='Updated upstream' &&
190 GITHEAD_$b_tree='Version stash was based on' &&
191 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
194 if git-merge-recursive $b_tree -- $c_tree $w_tree
197 if test -n "$unstashed_index_tree"
199 git read-tree "$unstashed_index_tree"
202 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
203 git read-tree --reset $c_tree &&
204 git update-index --add --stdin <"$a" ||
205 die "Cannot unstage modified files"
210 # Merge conflict; keep the exit status from merge-recursive
212 if test -n "$unstash_index"
214 echo >&2 'Index was not unstashed.'
221 have_stash || die 'No stash entries to drop'
225 set x "$ref_stash@{0}"
228 # Verify supplied argument looks like a stash entry
229 s=$(git rev-parse --revs-only --no-flags "$@") &&
230 git rev-parse --verify "$s:" > /dev/null 2>&1 &&
231 git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
232 git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
233 die "$*: not a valid stashed state"
235 git reflog delete --updateref --rewrite "$@" &&
236 echo "Dropped $* ($s)" || die "$*: Could not drop stash entry"
238 # clear_stash if we just dropped the last stash entry
239 git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
243 have_stash || die 'Nothing to apply'
245 test -n "$1" || die 'No branch name specified'
250 set x "$ref_stash@{0}"
254 git-checkout -b $branch $stash^ &&
255 apply_stash --index $stash &&
287 if test $# -gt 0 && test "$1" = create
291 create_stash "$*" && echo "$w_commit"
301 test -z "$unstash_index" || shift
313 echo '(To restore them type "git stash apply")'